/******************************************************************************/
/** \file main.c
 **
 ** A detailed description is available at
 ** @link Sample Group Some description @endlink
 **
 **   - 2021-03-12  1.0  xiebin First version for Device Driver Library of Module.
 **
 ******************************************************************************/
/*******************************************************************************
*
* 代码许可和免责信息
* 武汉芯源半导体有限公司授予您使用所有编程代码示例的非专属的版权许可，您可以由此
* 生成根据您的特定需要而定制的相似功能。根据不能被排除的任何法定保证，武汉芯源半
* 导体有限公司及其程序开发商和供应商对程序或技术支持（如果有）不提供任何明示或暗
* 含的保证或条件，包括但不限于暗含的有关适销性、适用于某种特定用途和非侵权的保证
* 或条件。
* 无论何种情形，武汉芯源半导体有限公司及其程序开发商或供应商均不对下列各项负责，
* 即使被告知其发生的可能性时，也是如此：数据的丢失或损坏；直接的、特别的、附带的
* 或间接的损害，或任何后果性经济损害；或利润、业务、收入、商誉或预期可节省金额的
* 损失。
* 某些司法辖区不允许对直接的、附带的或后果性的损害有任何的排除或限制，因此某些或
* 全部上述排除或限制可能并不适用于您。
*
*******************************************************************************/
/******************************************************************************
 * Include files
 ******************************************************************************/
#include "../inc/main.h"

/******************************************************************************
 * Local pre-processor symbols/macros ('#define')
 ******************************************************************************/

/******************************************************************************
 * Global variable definitions (declared in header file with 'extern')
 ******************************************************************************/

/******************************************************************************
 * Local type definitions ('typedef')
 ******************************************************************************/

/******************************************************************************
 * Local function prototypes ('static')
 ******************************************************************************/

/******************************************************************************
 * Local variable definitions ('static')                                      *
 ******************************************************************************/

/******************************************************************************
 * Local pre-processor symbols/macros ('#define')
 ******************************************************************************/

/*****************************************************************************
 * Function implementation - global ('extern') and local ('static')
 ******************************************************************************/

/**
 ******************************************************************************
 ** \brief  Main function of project
 **
 ** \return uint32_t return value, if needed
 **
 ** 将SWD端口配置成通用GPIO功能
 **
 ******************************************************************************/
int32_t main(void)
{
    uint32_t tmp32;

    //================================================================================
    //复位后延时2秒再将SWD接口变成GPIO，防止芯片被锁死
    InitTick(8000000); //SYSTICK 的工作频率为8MHz，每ms中断一次
    SysTickDelay(2000);

    //================================================================================
    //Open GPIOA Clk
    CW_SYSCTRL->AHBEN_f.GPIOA = 1;
    //将PA02 / PA05 配置成通用GPIO功能
    GPIO_SWD2GPIO();
    //配置 PA02 / PA05 为数字功能 - 输出
    REGBITS_CLR(CW_GPIOA->ANALOG, bv2 | bv5);
    REGBITS_CLR(CW_GPIOA->DIR, bv2 | bv5);

    tmp32 = GetTick() + 10000;
    while (GetTick() < tmp32) //在10秒内为GPIO功能
    {
        PA02_SETHIGH();
        PA05_SETHIGH();
        PA05_SETLOW();
        PA02_SETLOW();
        PA05_SETHIGH();
        PA05_SETLOW();
    }

    //================================================================================
    //配置 PA02 / PA05 为UART1.RXD / UART1.TXD
    REGBITS_CLR(CW_GPIOA->ANALOG, bv2 | bv5);         //设置PA02/PA05为数字功能
    REGBITS_MODIFY(CW_GPIOA->DIR, bv2 | bv5, bv2);    //设置PA02为输入，PA05为输出
    PA02_AFx_UART1RXD();                              //配置PA02为UART1.RXD
    PA05_AFx_UART1TXD();                              //配置PA05为UART1.TXD

    //================================================================================

    while (1)
    {
        ;
    }

    //================================================================================
}

/******************************************************************************
 * EOF (not truncated)
 ******************************************************************************/
